import { closeIcon } from '@genesislcap/foundation-ui';
import { sync } from '@genesislcap/foundation-utils';
import { html, repeat, when } from '@microsoft/fast-element';
import { ALL_SEVERITIES_TYPES } from './main.config';
/**
 * @public
 */
export const FoundationInboxTemplate = html `
  <section class="section header">
    <h5 class="title">Alert log</h5>
    <zero-select class="select-filter" :value=${sync((x) => x.severity)}>
      <zero-option>Filters Alerts by Type</zero-option>
      ${repeat((x) => ALL_SEVERITIES_TYPES, html `
          <zero-option value="${(x) => x}">${(x) => x}</zero-option>
        `)}
    </zero-select>
    <zero-button class="button-close" @click="${(x) => x.$emit('close')}">
      ${closeIcon()}
    </zero-button>
  </section>
  <section class="section section-search">
    <zero-text-field
      class="input-search"
      :value=${sync((x) => x.searchText)}
      placeholder="Search Alerts ..."
    ></zero-text-field>
  </section>
  <section class="wrapper">
    <div class="wrapper-scroll">
      ${when((x) => x.isLoading, html `
          <div class="loading-spinner-container"><zero-progress-ring></zero-progress-ring></div>
        `)}
      ${when((x) => !x.isLoading, html `
          ${when((x) => x.notifiesToDisplay.length === 0, html `
              <p class="no-notifiactions-info">There are no notifications to display</p>
            `)}
          ${repeat((x) => x.notifiesToDisplay, html `
              <foundation-inbox-toast class="toast" notify="${(x) => x.type}" id="${(x) => x.id}">
                <h6 class="toast-title" slot="top">${(x) => x.title} ${(x) => x.type}</h6>
                <p class="toast-content" slot="content">${(x) => x.content}</p>
                <section class="toast-bottom" slot="bottom">
                  <span class="toast-date" slot="date">${(x) => x.date}</span>
                  ${when((x) => { var _a; return (_a = x.actions) === null || _a === void 0 ? void 0 : _a.length; }, html `
                      ${repeat((x) => x.actions, html `
                          <zero-button
                            appearance="${(x) => x.cssClass}"
                            @click=${(action) => action.fn()}
                          >
                            ${(action) => action.text}
                          </zero-button>
                        `)}
                    `)}
                  <zero-dropdown-menu
                    class="toast-dropdown"
                    name=""
                    :items=${(x, c) => c.parent.toastMenuItems.map((item) => (Object.assign(Object.assign({}, item), { callback: item === null || item === void 0 ? void 0 : item.callback.bind(this, c) })))}
                  />
                    <zero-icon name="ellipsis-vertical" variant="solid" size="lg"><zero-icon>
                  </zero-dropdown-menu>
                </section>
              </foundation-inbox-toast>
            `)}
        `)}
    </div>
  </section>
`;
